;
;*******************************************************
;*******************************************************
;**                                                   **
;**    Sztuka programowania mikrokontrolerow AVR      **
;**                  Drugi program                    **
;**                  wariant trzeci                   **
;**                                                   **
;**       Andrzej Pawluczuk                           **
;**                                                   **
;**         Mikrokontroler: ATMeGA8515                **
;**                Bialystok, 2006                    **
;**                                                   **
;*******************************************************
;*******************************************************
;
	.nolist
;*******************************************************
.include "m8515def.inc"
;*******************************************************
	.list
;---------------------------------------------------------------
.def acc	= r16
;---------------------------------------------------------------
	.cseg
;---------------------------------------------------------------
	.org	0		;
	rjmp	ResetProcessor	;
;---------------------------------------------------------------
EnvirInit :			;
	ldi	acc,0b00000000	;
	out	DDRA,acc	;
	ldi	acc,0b11111111	;
	out	PORTA,acc	;
	ldi	acc,0b11111111	;
	out	DDRB,acc	;
	ldi	acc,0b11111111	;
	out	PORTB,acc	;
	ret			;
;---------------------------------------------------------------
ResetProcessor :		;
	ldi	acc,HIGH(RAMEND);
	out	SPH,acc		;
	ldi	acc,LOW(RAMEND) ;
	out	SPL,acc		;
;---------------------------------------------------------------
Main	:			;
	rcall	EnvirInit	;
	ldi	acc,0b11111110	;
	out	PortB,acc	;
Main_0	:			;
	ldi	acc, 0		;
	sbis	PINA,0		;
	ldi	acc, 0b11111110	;
	sbis	PINA,1		;
	ldi	acc, 0b11111101	;
	sbis	PINA,2		;
	ldi	acc, 0b11111011	;
	sbis	PINA,3		;
	ldi	acc, 0b11110111	;
	sbis	PINA,4		;
	ldi	acc, 0b11101111	;
	sbis	PINA,5		;
	ldi	acc, 0b11011111	;
	sbis	PINA,6		;
	ldi	acc, 0b10111111	;
	sbis	PINA,7		;
	ldi	acc, 0b01111111	;
	cpi	acc,0		;
	breq	Main_0		;
	out	PortB,acc	;
	rjmp	Main_0		;
;---------------------------------------------------------------
.exit
